-----------------------------------------------------------------------
global function SPT_to_RLE_0_0(sequence spt)
  integer cnt, last_colr
  sequence rle
  last_colr = spt[1]
  cnt = 0
  rle = {spt[1]}
  for A = 2 to length(spt) do
    if spt[A] = last_colr then--If spt[A] = last_colr
      cnt = cnt + 1--add 1 to cnt
    else--if spt[A] is another color
      while cnt > 255 do--if cnt is to big, put out in pieces.
	rle = rle & {255, last_colr}--put out 256 of total cnt and last_colr.
	cnt = cnt - 256--decrease cnt to show how many left.
      end while
      rle = rle & {cnt, spt[A]}
      --put out how many of last_colr & spt[A] color(this color)
      last_colr = spt[A]--set last_colr to spt[A](this color)
      cnt = 0--clear cnt for next color.
    end if
  end for
  --this flushes last of spt to the rle
  while cnt > 255 do--if cnt is to big, put out in pieces.
    rle = rle & {255, last_colr}--put out 256 of total cnt and last_colr.
    cnt = cnt - 256--decrease cnt to show how many left.
  end while
  rle = rle & cnt
  --put out how many of last_colr & spt[A] color(this color)
  --last_colr = spt[A]--set last_colr to spt[A](this color)
  return {0, 0} & rle--return the compressed code.
end function
-----------------------------------------------------------------------
global function SPT_to_RLE_0_1(sequence spt)
  atom cnt, l
  sequence rle
  cnt = 0
  rle = {}
  l = length(spt)
  for A = 1 to l - 1 do
    if spt[A] = spt[A + 1] then
      cnt = cnt + 1
    else
      while cnt > 255 do
	rle = rle & {255, spt[A]}
	cnt = cnt - 256
      end while
      rle = rle & {cnt , spt[A]}
      cnt = 0--clear cnt for next run
    end if
  end for
  while cnt > 255 do--flush cnt
    rle = rle & {255, spt[l]}
    cnt = cnt - 256
  end while
  rle = rle & {cnt , spt[l]}
  return {0, 1} & rle--return the compressed code.
end function
-----------------------------------------------------------------------
global function SPT_to_RLE_1_0(sequence spt)
  atom l, ps
  integer chr, cnt
  sequence rle, hold

  rle = {}
  l = length(spt)
  spt = spt & repeat(spt[l] = 0, 2)
  l = l + 1
  chr = spt[1]
  ps = 2
  while l >= ps do
    if chr = spt[ps] then
      cnt = 0
      while chr = spt[ps] and l > ps do
	ps = ps + 1
	cnt =  cnt + 1
	if cnt = 127 then
	  rle = rle & {cnt, chr}
	  cnt = -1
	end if
      end while
      if cnt != -1 then
	rle = rle & {cnt, chr}
      end if
      chr = spt[ps]
      ps = ps + 1
    else
      cnt = 127
      hold = {}
      while chr != spt[ps] and l > ps or l = ps do
	hold = hold & chr
	cnt =  cnt + 1
	chr = spt[ps]
	ps = ps + 1
	if cnt = 255 then
	  rle = rle & cnt & hold
	  hold = {}
	  cnt = 127
	end if
      end while
      if cnt > 127 then
	rle = rle & cnt & hold
      end if
    end if
  end while
  return {1,0} & rle
end function
-----------------------------------------------------------------------
global function SPT_to_RLE(sequence spt)
  if sequence(spt[1]) then
    if compare(spt[1], {0, 0}) = 0 then
      return SPT_to_RLE_0_0(spt[2])
    elsif compare(spt[1], {0, 1}) = 0 then
      return SPT_to_RLE_0_1(spt[2])
    elsif compare(spt[1], {1, 0}) = 0 then
      return SPT_to_RLE_1_0(spt[2])
    end if
    spt = spt[2]
  end if
  return SPT_to_RLE_1_0(spt)
end function
-----------------------------------------------------------------------
global function RLE_to_SPT_0_0(sequence rle)
  sequence spt
  spt = {}
  for A = 1 to length(rle) - 1 by 2 do--loop while there is code to decompress.
    spt = spt & repeat(rle[A], rle[A + 1] + 1)
      --put rle[cnt + 1] number of color to spt.
  end for
  return spt--return decompressed code.
end function
-----------------------------------------------------------------------
global function RLE_to_SPT_0_1(sequence rle)
  sequence spt
  spt = {}
  for A = 1 to length(rle) - 1 by 2 do--loop while there is code to decompress.
    spt = spt & repeat(rle[A + 1], rle[A] + 1)
      --put rle[cnt + 1] number of color to spt.
  end for
  return spt--return decompressed code.
end function
-----------------------------------------------------------------------
global function RLE_to_SPT_1_0(sequence rle)
  atom A, l
  integer cnt
  sequence spt

  A = 1
  spt = {}
  l = length(rle)
  while l >= A do
    if rle[A] > 127 then
      cnt = rle[A] - 128
      A = A + 1
      spt = spt & rle[A..A + cnt]
      A = A + cnt + 1
    else
      cnt = rle[A] + 1
      spt = spt & repeat(rle[A + 1], cnt)
      --put rle[cnt + 1] number of color to spt.
      A = A + 2
    end if
  end while
  return spt--return decompressed code.
end function
-----------------------------------------------------------------------
global function RLE_to_SPT(sequence rle)
  sequence ver
  ver = rle[1..2]
  rle = rle[3..length(rle)]
  if compare(ver, {0, 0}) = 0 then
    return RLE_to_SPT_0_0(rle)
  elsif compare(ver, {0, 1}) = 0 then
    return RLE_to_SPT_0_1(rle)
  elsif compare(ver, {1, 0}) = 0 then
    return RLE_to_SPT_1_0(rle)
  end if
  return -1
end function
-----------------------------------------------------------------------

-- In Euphoria 2.1 this file (unless modified) is FREE - 0 statements.
with 67601768 -- delete this statement if it causes an error

